//--------------------------------------------------------------------------------------------------
//
// Title       : invert_test
// Design      : invert
// Author      : 
// Company     : 
//
//-------------------------------------------------------------------------------------------------
//
// File        : invert_test.v
// Generated   : Fri Jan 24 17:29:23 2003
// From        : interface description file
// By          : Itf2Vhdl ver. 1.20
//
//-------------------------------------------------------------------------------------------------
//
// Description : 
//
//-------------------------------------------------------------------------------------------------
`timescale 10ns / 1ns
// 0.000 000 02
//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {invert_test}}
module invert_test ( recv );
	
	output  recv ;
	wire  recv ;
	reg clock;
	reg reset;
	wire send;
	wire baud_clock;
	
	parameter startBit = 0;
	parameter stopBit = 1;
	reg [7:0] testSerValue;
	reg [3:0] bitCounter;
	//}} End of automatically maintained section
	
	// -- Enter your statements here -- //
	invert serialInverter( 
		clock,
		reset,
		recv,
		send,
		baud_clock
		);	  
	
	initial	
		begin
			clock = 0;
			reset = 1;
			#4 reset = 0;   // 2 clock periods
			testSerValue = 0;				  
			bitCounter = 0;
		
		end
	
	
	assign recv = getSerialBit( testSerValue, bitCounter );		
	
	wire [3:0] newBitValue;
	
	assign newBitValue = bitRollover( bitCounter );
	
	
	always @(posedge baud_clock	)
		begin
			bitCounter <= newBitValue;	
		end	 
	
	always @(posedge baud_clock)
		begin
			if( bitCounter == 9 )
				testSerValue <= testSerValue + 1;
		end
	
	always 
		#2 clock = ~clock;  // 20 ns clock	 
	
	
	function [3:0] bitRollover;
		input [3:0] bitCounter;
		if( bitCounter > 9 )
			bitRollover = 0;
		else
			bitRollover = bitCounter + 1;
	endfunction
	
	
	function getSerialBit;
		input [7:0] serialByte;
		input [3:0] bitSelect;
		
		case( bitSelect )
			4'b0000:	getSerialBit = startBit;
			4'b0001:	getSerialBit = serialByte[0];
			4'b0010:	getSerialBit = serialByte[1];
			4'b0011:	getSerialBit = serialByte[2];
			4'b0100:	getSerialBit = serialByte[3];
			4'b0101:	getSerialBit = serialByte[4]; 
			4'b0110:	getSerialBit = serialByte[5];
			4'b0111:	getSerialBit = serialByte[6];
			4'b1000:	getSerialBit = serialByte[7];
			4'b1001:	getSerialBit = stopBit;
			default:	getSerialBit = stopBit; 
		endcase
		
	endfunction
	
endmodule
